第八周课程总结&实验报告(六)

编写一个类,在其main()方法中创建一个一维数组,在try字句中访问数组元素,使其产生ArrayIndexOutOfBoundsException异常。在catch子句里捕获此异常对象,并且打印“数组越界”信息,加一个finally子句,打印一条信息以证明这里确实得到了执行。
自定义异常类的使用
实验代码:

public class Exception {
    public static void main(String args[]) {
        System.out.println("*********计算开始 *********");

        try {
            int score[] = {0, 1, 2, 3, 4, 5};
            System.out.println("输出第七个数组元素:" + score[7]);
        }
               catch(ArrayIndexOutOfBoundsException e){
                System.out.println("数组越界:"+e);
        }
        finally {
            System.out.println("程序执行完毕");
        }

    }
}

运行结果截图:

分享图片

车站检查危险品的设备,如果发现危险品会发出警告。编程模拟设备发现危险品。

技术方案:

编写一个Exgeption的子类DangerException,该子类可以创建异常对象,该异常对象调用toShow()方法输出“危险物品”。编写一个Machine类,该类的方法checkBag(Goods goods)当发现参数goods是危险品时(goods的isDanger属性是true)将抛出DangerException异常。
程序在主类的main()方法中的try-catch语句的try部分让Machine类的实例调用checkBag(Goods goods)的方法,如果发现危险品就在try-catch语句的catch部分处理危险品。
实验代码:

class DangerException extends Exception {
     public void toShow() {
            System.out.println("危险物品");
        }
}
public class Goods {
     private boolean Danger;
        private String name;
        public Object getName;
        public Goods(boolean Danger,String name) {
            this.Danger=Danger;
            this.name=name;
        }
        public boolean Danger() {
            return Danger;
        }
        public void setName(String name) {
            this.name=name;
        }
        public String getName() {
            return name;
        }

    }
public class Machine {
    public void checkBag(Goods goods)throws DangerException{
        if(goods.Danger()) 
            throw new DangerException();
        else
            System.out.println(goods.getName()+"不是危险品");
    }
}
public class Test{

    public static void main(String[] args){
        Machine mac=new Machine();
        Goods goods=new Goods(false, null);
        String a[]={"大炮","刀","本子"};
        for(int i=0;i<a.length;i++) {
            goods.setName(a[i]);
            if(a[i].equals("大炮")||a[i].equals("刀")) {
                goods.Danger();
                System.out.println(a[i]+"是危险品");
            }
            else
                goods.Danger();
        }

        try {
            mac.checkBag(goods);
        }catch(DangerException e) {
            e.toShow();
        }
    
    }
}

运行结果截图:
分享图片

课后总结: 1.详细的了解了try{}catch{}finally{}的基本用法,加上此方法的多次运用,掌握了其中的精髓。但是还是不是很透彻,会在此有一定基础上多加功夫。 2.初步了解了Thread类runnable接口的运用方法 3.老师详细的解说了throw与throws的区别,理解的更加透彻了 4.继续撸起袖子加油干!!!

相关文章
相关标签/搜索